// ** AUTO-UI IMPORT STATEMENTS **
// ** END AUTO-UI IMPORT STATEMENTS **



import hr.skolskaknjiga.wordshuffle.*;

class hr.skolskaknjiga.wordshuffle.InsertSentence extends Sentence {

	public static var CLASS_REF = hr.skolskaknjiga.wordshuffle.Sentence;
	public static var LINKAGE_ID:String = "Sentence";

	///private var EB:EventBroadcaster;
	
	private var inserts:Array;
	
	private var opt:Object;

// ** AUTO-UI ELEMENTS **
// ** END AUTO-UI ELEMENTS **

	//////////////////////////////
	//////// CONSTRUCTOR /////////
	//////////////////////////////
	public function InsertSentence() {
		///EB = EventBroadcaster.getInstance();
		inserts = new Array();
		opt = _global.shuffleMain.options;
	}
	private function onLoad() {
	}

	//////////////////////////////
	/////////// PUBLIC ///////////
	//////////////////////////////
	public function generateWords(stc:TextField):Void {
		super.generateWords(stc);
		for (var i:Number = 0; i < words.length; i++) {
			var wMC:Word = Word(this.attachMovie("Word", "w" + i, this.getNextHighestDepth()));
			///var wMC:DraggableWord = DraggableWord(this.attachMovie("DraggableWord", "w" + i, this.getNextHighestDepth()));
			wMC.text = words[i];
			wMC.format = origTFormat;
			wordMCs.push(wMC);
		}
		positionWords();
	}
	
	public function makeInserts(insts:Array):Void {
		for (var i:Number = 0; i < insts.length; i++) {
			var iTF:TextField = insts[i];
			var iMC:InsertableWord = InsertableWord(this.attachMovie("InsertableWord", "insert" + i, this.getNextHighestDepth()));
			iMC.text = iTF.text;
			for (var w:Number = wordMCs.length-1; w >= 0; w--) {
				var wMC:Word = wordMCs[w];
				if (wMC.text == iMC.text) {
					wordMCs.splice(w, 1);
					wMC.removeMovieClip();
				}
			}
			inserts.push(iMC);
			iTF._visible = false;
		}
		positionWords();
		for (i = 0; i < inserts.length; i++) {
			iMC = inserts[i];
			var prev = inserts[i - 1];
			if (prev == null) prev = { _x:0, _width:0 };
			var lastW:Word = wordMCs[wordMCs.length - 1];
			if (i == 0) iMC._x = (opt.insert_position_mode == "distance")? lastW._x + lastW._width + opt.distance_to_insert_words	:	opt.position_of_insert_words; 
			else iMC._x = prev._x + prev._width + opt.word_distance;
			iMC.format = lastW.format;
		}
		
	}
	
	public function addInsertToSentence(ins:InsertableWord):Void {
		wordMCs.push(ins);
		ins.inserted = true;
	}

	//////////////////////////////
	/////////// PRIVATE //////////
	//////////////////////////////

} 