// ** AUTO-UI IMPORT STATEMENTS **
// ** END AUTO-UI IMPORT STATEMENTS **


import hr.skolskaknjiga.wordshuffle.*;

class hr.skolskaknjiga.wordshuffle.RandomSentence extends Sentence {

	public static var CLASS_REF = hr.skolskaknjiga.wordshuffle.Sentence;
	public static var LINKAGE_ID:String = "Sentence";

	///private var EB:EventBroadcaster;

// ** AUTO-UI ELEMENTS **
// ** END AUTO-UI ELEMENTS **

	//////////////////////////////
	//////// CONSTRUCTOR /////////
	//////////////////////////////
	public function RandomSentence() {
		///EB = EventBroadcaster.getInstance();
	}
	private function onLoad() {
	}

	//////////////////////////////
	/////////// PUBLIC ///////////
	//////////////////////////////
	public function generateWords(stc:TextField):Void {
		super.generateWords(stc);
		for (var w:Number = 0; w < words.length; w++) {
			var wMC;
			if (Boolean(options.exclude_first_and_last)) {
				if (w == 0 || w == words.length - 1) wMC = Word(this.attachMovie("Word", "w" + w, this.getNextHighestDepth()));
				else wMC = Word(this.attachMovie("DraggableWord", "w" + w, this.getNextHighestDepth()));
			}
			else wMC = Word(this.attachMovie("DraggableWord", "w" + w, this.getNextHighestDepth()));
			wMC.text = words[w];
			wMC.format = origTFormat;
			wordMCs.push(wMC);
		}
		randomizeWords();
		positionWords();
	}


	//////////////////////////////
	/////////// PRIVATE //////////
	//////////////////////////////
	private function randomizeWords():Void {
		var wCopy:Array = cloneArray(wordMCs);
		var randomizedArr:Array = new Array();
		var excl:Boolean = Boolean(options.exclude_first_and_last);
		if (excl) {
			randomizedArr.push(wCopy.shift());
		}
		while (wCopy.length > 1) {
			var lgt:Number = (excl)? wCopy.length - 1 : wCopy.length;
			var idx:Number = Math.floor(Math.random() * lgt);
			var spliced = wCopy.splice(idx, 1)[0];
			randomizedArr.push(spliced);
		}
		randomizedArr.push(wCopy.pop());
		wordMCs = randomizedArr;
	}
	

} 